Index: byterun/sys.c
===================================================================
RCS file: /caml/ocaml/byterun/sys.c,v
retrieving revision 1.59
diff -r1.59 sys.c
256a257,298
> #if defined(SYS_rhapsody)
> int rhapsody_system(const char *string) {
>     int old_sigmask;
>     pid_t pid;
> 
>     if (string == 0)
> 	return 1;
>     old_sigmask = sigblock(sigmask(SIGQUIT));
>     pid = vfork();
>     if (pid < 0) {
> 	/* vfork failed */
> 	sigsetmask(old_sigmask);
> 	return -1;
>     } else if (pid == 0) {
> 	/* We are in the child process */
> 	sigsetmask(old_sigmask);
> 	execl("/bin/sh", "sh", "-c", string, 0);
> 	_exit(127);
> 	return -1;
>     } else {
> 	/* We are in the parent process */
> 	int status = 0;
> 	void* old_sigint;
> 	void* old_sigquit;
> 	int result;
> 
> 	old_sigint = signal(SIGINT, 0);
> 	old_sigquit = signal(SIGQUIT, 0);
> 	do {
> 	    result = waitpid(pid, &status, 0);
> 	} while (result < 0 && errno == EINTR);
> 	signal(SIGINT, old_sigint);
> 	signal(SIGQUIT, old_sigquit);
> 	sigsetmask(old_sigmask);
> 	if (result < 0)
> 	    return -1;
> 	else
> 	    return status;
>     }
> }
> #endif
> 
262a305,307
> #if defined(SYS_rhapsody)
>   status = rhapsody_system(String_val(command));
> #else
263a309
> #endif
